#ifndef _97398130_0167_4650_8750_EEE65FA2501B_
# define _97398130_0167_4650_8750_EEE65FA2501B_

#if defined(WIN32)

#define MYCALLTYPE WINAPI

#else // WIN32

#define MYCALLTYPE
#define HANDLE pthread_t
#define DWORD unsigned long
#define LPVOID void*
#define _snprintf snprintf
#define __COUNTER__ ""

#include <unistd.h>
#define Sleep(n) usleep((n)*1000)

#endif // WIN32


#include <cstring>
#include <string>
#include <vector>

using namespace std;

#define CURL_STATICLIB
#include "curl/curl.h"

#include "openssl/pkcs7.h"
#include "openssl/ts.h"
#include "openssl/x509v3.h"
#include "openssl/asn1t.h"
#include "openssl/asn1.h"
#include "openssl/pkcs7.h"
#include "openssl/ocsp.h"
#include "openssl/pkcs12.h"
#include "openssl/pem.h"
#include "openssl/ssl.h"
#include "openssl/err.h"

#define SNPRINTF _snprintf

#define TM_TSA				(1 << 0)
#define TM_OCSP				(1 << 1)


#define PARAM_VERBOSE		 (1 << 0)
#define PARAM_VALIDATE		 (1 << 1)
#define PARAM_TSAREQ_SHA256	 (1 << 2)
#define PARAM_OCSPREQ_SHA256 (1 << 2)

void *myrealloc(void *ptr, size_t size);
string my_printhex(const void* b, int size);
void OpenSSLDebug();
int GetCertAndPrivKey(const string& path, const string& password // in
				, X509*& pCert, EVP_PKEY*& pPrivateKey);

typedef struct sslctxparm_st {
	unsigned char * p12file ;
	const char * pst ;
	PKCS12 * p12 ;
	EVP_PKEY * pkey ;
	X509 * usercert ;
	STACK_OF(X509) * ca ;
	CURL * curl;
	BIO * errorbio;
	int accesstype ;
	int verbose;
} SSLCTXPARAM;

struct MemoryStruct {
	unsigned char *memory;
	size_t size;

	MemoryStruct(unsigned char *m, size_t s)
	: memory(m)
	, size(s)
	{
		;
	}

	MemoryStruct()
	{
		MemoryStruct(NULL,0);
	}
};

extern int g_initThreadCnt;
extern bool g_startThreads;
extern int g_reqCnt;
extern int g_tsReqCnt;
extern int g_oscpReqCnt;
extern unsigned param_threadNo;
extern unsigned param_numOfQueries;
extern int param_testmode;
extern string param_tsa_authMode;
extern string param_tsa_url;
extern string param_tsa_pfx;
extern string param_tsa_userName;
extern string param_tsa_passw;
extern string param_ocsp_authMode;
extern string param_ocsp_url;
extern string param_ocsp_pfx;
extern string param_ocsp_userName;
extern string param_ocsp_passw;
extern string param_ocsp_cert;
extern string param_ocsp_issuer;
extern string param_qpattern;
extern int param_mask;

#endif // _97398130_0167_4650_8750_EEE65FA2501B_
